library ieee;
use ieee.std_logic_1164.all;


entity semaphore is
port (clk, rst, SEO: in std_logic;
      NSred,NSyellow,NSgreen: out std_logic;
      EWred,EWyellow,EWgreen: out std_logic;
      st,conto : out integer
);
end semaphore;

architecture beh of semaphore is
  type stati is (NSverde,NSgiallo,EWverde,EWgiallo);
  signal nextstate: stati;
  signal maxconto: integer:= 60;
  signal fineconto,start,startclk: std_logic;
  signal c: integer;
 begin
     
    process (clk,rst)
      
      begin
        if rst='1' then nextstate <= NSverde;
        		st<= 0;
        		start<='1';
        		
        elsif clk'event and clk='0' then 
             case nextstate is
               when NSverde =>  if SEO = '1' and fineconto='1'
               				then nextstate <= NSgiallo;
               				     start<= '1';
               				     st<=1;
               				                  		
               		        else nextstate <= NSverde;
               		             start<= '0';
               		             
               			end if;
               when NSgiallo => if fineconto='1'
               				then  nextstate <= EWverde;
               				      start<='1';
               				      st<=2;
               				      		
               			else nextstate <= NSgiallo;
               			     start<='0';
               			     
               			end if;
               when EWverde =>  
        			
               			if fineconto='1'
               			       then nextstate <= EWgiallo;
               			            start<='1';
               			            st<= 3; 
               			            
               			else nextstate <= EWverde;
               			     start<='0';
               			     
               			end if;
               when EWgiallo => 
        		
               			if fineconto='1' then nextstate <= NSverde;
               				           start<='1';
               				           st<= 0;
                                else nextstate<= EWgiallo;
                                     start<='0';
                                     
                                end if;
               when others => null;
             end case;
           end if;
           
        end process;
    
   
    process(nextstate)
     begin
       case nextstate is
        when NSverde => NSred<= '0';
        		NSyellow <= '0';
        		NSgreen <= '1';
        		EWred<='1';
        		EWyellow<='0';
        		EWgreen<='0';
        		maxconto<= 60;
        		
        when NSgiallo => NSred<= '0';
        		NSyellow <= '1';
        		NSgreen <= '0';
        		EWred<='1';
        		EWyellow<='0';
        		EWgreen<='0'; 
        		maxconto<= 2;
        		
        when EWverde => NSred<= '1';
        		NSyellow <= '0';
        		NSgreen <= '0';
        		EWred<='0';
        		EWyellow<='0';
        		EWgreen<='1';
        		maxconto<= 30;
        		
        when EWgiallo => NSred<= '1';
        		NSyellow <= '0';
        		NSgreen <= '0';
        		EWred<='0';
        		EWyellow<='1';
        		EWgreen<='0';
        		maxconto<= 2;
        		
        when others => null;
       end case;
  end process;
       
 process(clk,start)
  
  begin
  if start  = '1' and c /=0
      then c<= 0;   
     
   elsif clk'event and clk='0' and fineconto /= '1'then
      
        c<= c+1;
    end if; 
          
        
   end process; 
  
  fineconto <= '0' when c<maxconto-1 
  
          else '1';
   
  
        		       
   conto <= c;          			
 end beh;          			








