library ieee;

use ieee.std_logic_1164.all;
use work.dati.all;

entity convertitore is
 port(  rst,clk, seriale: in std_logic;
        parallelo: out std_logic_vector(7 downto 0);
        pronto: out std_logic;
        st: out stato );
end convertitore;

architecture beh of convertitore is

 signal tmp: std_logic_vector(7 downto 0);
 signal cs,nxs: stato;
 signal shift_en,update_en: std_logic;
 begin
 st <= cs;
 
 process(rst, clk)
  begin
    if rst='1' then
       cs<= idle;-- after 1 ns;
    elsif clk'event and clk='1'  then
       
     case cs is
      when  idle =>
             if seriale = '1'  then         
             cs<= idle;
          else cs<= b7;
          end if;
       when b7 => cs <= b6; 
       when b6 => cs <= b5; 
       when b5 => cs <= b4; 
       when b4 => cs <= b3; 
       when b3 => cs <= b2; 
       when b2 => cs <= b1; 
       when b1 => cs <= b0; 
       when b0 => cs <= update; 
       when update => cs <= idle; 
       when others => cs <= idle; 
     end case;
     end if;
   end process;
   
   process(cs)
   begin
    
    case cs is
      when  idle =>  shift_en<= '0'; update_en <= '0';
          
       when b7 => shift_en<= '1'; update_en <= '0';
       when b6 => shift_en<= '1'; update_en <= '0';
       when b5 => shift_en<= '1'; update_en <= '0';
       when b4 => shift_en<= '1'; update_en <= '0';
       when b3 => shift_en<= '1'; update_en <= '0';
       when b2 => shift_en<= '1'; update_en <= '0';
       when b1 => shift_en<= '1'; update_en <= '0';
       when b0 => shift_en<= '1'; update_en <= '0';
       when update =>shift_en<= '0'; update_en <= '1';
       when others => shift_en<= '0'; update_en <= '0';
     end case;
     
   end process;
   
   process(rst,clk)
     begin
      if rst = '1' then 
      	  tmp <= "00000000";
      elsif clk'event and clk = '1' then
          if shift_en = '1' then
             tmp<=tmp(6 downto 0)&seriale;
          end if;
      end if;
     end process;
     
    process(rst,clk)
     begin
      if rst = '1' then 
      	  parallelo <= "00000000";
      	  pronto <= '0';
      elsif clk'event and clk = '1' then
          pronto<= update_en;
          if update_en = '1' then
             parallelo <= tmp;
          end if;
      end if;
     end process;
end beh;
         
     
      

