library ieee;

use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity centro is
  port ( rst, clk, nw: in std_logic;
         din: in std_logic_vector(15 downto 0);
         ris: out std_logic_vector(15 downto 0 );
         ready: out std_logic
  );
 end centro;
 
 architecture beh of centro is
 
 type stati is (idle, leggin, valorex, valored, prodotto, somma,calcola,fine);
 signal cs: stati;
 signal conto,numero: integer;
 signal leggi: std_logic;
 signal sp, p,D,X  : std_logic_vector(15 downto 0);

 begin
 
 process(clk,rst,nw)
 begin
  if rst= '1' then cs <= idle;
  elsif clk'event and clk='0' then
     case cs is 
       when idle => if nw = '1' then cs <= leggin;
       		    else cs <= idle;
       		    end if;
       when leggin => cs <= valorex;
       		      
       when valorex => cs <= valored;
       when valored => cs <= prodotto;
	when prodotto => cs <= somma;
       when somma =>  if conto = numero then cs <= calcola;
                       else cs <= valorex;
                      end if;
       when calcola => cs <= fine;
       when fine => cs <= idle;
       when others => cs <= idle;
     end case;
     end if;
    end process;
    
  process(clk, cs)
  begin
    if clk'event and clk='0' and cs=leggin then
       numero <= conv_integer(din);
    end if;
  end process;
  
  process(clk,nw,cs)
   begin
    if nw ='1' then conto<= 0;
    elsif clk'event and clk='0' and cs=valorex then
                  conto<=conto+1;
    end if;
   end process;
   
   process(clk,nw)
    begin
     if nw= '1' then sp<=(sp'range=>'0');
     elsif clk'event and clk='0' then
         if cs=prodotto then p <= X(7 downto 0)*D(7 downto 0);
          elsif cs =somma then
            sp <= sp + p;
            
         end if;
      end if;
     end process;
   
   process(clk,cs)
    begin
      if clk'event and clk='0' and cs = calcola then
         ris <= sp;
      end if;
   end process;
   
   process(clk,cs)
   begin
    if clk'event and clk='0' and cs = valored then
       D<= din;
    end if;
    end process;
    
    process(clk,cs)
   begin
    if clk'event and clk='0' and cs = valorex then
       X<= din;
    end if;
    end process;
   
   ready <= '1' when cs = fine else
            '0';
          			
  end beh;
  
   
   
   
    



